#include <iostream>

using namespace std;

enum Flags
{
	F_EXECUTABLE = 1,
	F_WRITEABLE = 2,
	F_READABLE = 4
};

void test(int flag)
{
	cout << "Read: " << (flag & F_READABLE ? "true" : "false")
		<< ", Write: " << (flag & F_WRITEABLE ? "true" : "false")
		<< ", Exec: " << (flag & F_EXECUTABLE ? "true" : "false")
		<< endl;
}

int main()
{
	int flag = F_READABLE | F_WRITEABLE | F_EXECUTABLE;
	cout << "flag = F_READABLE | F_WRITEABLE | F_EXECUTABLE;" << endl;
	test(flag);
	
	flag = flag & F_READABLE;
	cout << "flag = flag & F_READABLE;" << endl;
	test(flag);
	
	flag = flag | F_EXECUTABLE;
	cout << "flag = flag | F_EXECUTABLE;" << endl;
	test(flag);
	
	if(flag & F_READABLE)
		cout << "flag has read permission" << endl;
	else
		cout << "flag does not have permission" << endl;
	
	return 0;
}
